#ifndef CONSTEXPR__H
#define CONSTEXPR__H 

#include <array> 

constexpr int N = 10; // Must be initialized
constexpr int Native_array[N] = {}; // Must be initialized

constexpr int Primes_() {
    int cursor = 0;
    for (int i = 2; cursor != N; i++) { // Candidate prime numbers...
        // Naive solution:
        bool is_prime = true;
        for (int j = 2; j < i; j++)
            if (i % j == 0) {
                is_prime = false;
                break;
            }
        //        if (is_prime)
        //            // Compilation error: assignment of read-only location:
        //            Native_array[cursor++] = i;
    }
	return 0; // Done...
}

 int Return = Primes_(); // This code causes the compiler to crash in a random way!
 // static_assert(::Native_array[0] == 2); // It fails!

constexpr std::array<int, N> Primes() {
    std::array<int, N> primes = {}; // Must be initialized
    int cursor = 0;
    for (int i = 2; cursor != N; i++) { // Candidate prime numbers...
        // Naive solution:
        bool is_prime = true;
        for (int j = 2; j < i; j++)
            if (i % j == 0) {
                is_prime = false;
                break;
            }
        //        if (is_prime)
        //            // Compilation error: call to non-'constexpr' function:
        //            primes[cursor++] = i;
        return primes;
    }
}

class Constexpr_example {
public:
    constexpr static std::array<int, N> Primes = ::Primes();
};

#endif /* CONSTEXPR__H */

